package com.zanxiang.game.back.serve.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.game.back.serve.dao.mapper.GameTencentOrderSplitLogMapper;
import com.zanxiang.game.back.serve.pojo.entity.GameTencentOrderSplitLog;
import com.zanxiang.game.back.serve.pojo.vo.GameTencentOrderSplitLogVO;
import com.zanxiang.game.back.serve.service.IGameTencentOrderSplitLogService;
import com.zanxiang.module.util.NumberUtil;
import com.zanxiang.module.util.bean.BeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class GameTencentOrderSplitLogServiceImpl extends ServiceImpl<GameTencentOrderSplitLogMapper, GameTencentOrderSplitLog>
        implements IGameTencentOrderSplitLogService {

    @Override
    public List<GameTencentOrderSplitLogVO> listByOrderNo(Collection<String> orderNos) {
        if (CollectionUtils.isEmpty(orderNos)) {
            return Collections.emptyList();
        }
        return list(new LambdaQueryWrapper<GameTencentOrderSplitLog>()
                .in(GameTencentOrderSplitLog::getOrderNo, orderNos)
                .orderByAsc(GameTencentOrderSplitLog::getBackIndex)
        ).stream().map(this::toVOSimple).collect(Collectors.toList());
    }

    private GameTencentOrderSplitLogVO toVOSimple(GameTencentOrderSplitLog log) {
        if (log == null) {
            return null;
        }
        GameTencentOrderSplitLogVO vo = BeanUtil.copy(log, GameTencentOrderSplitLogVO.class);
        if (log.getSplitMoney() != null) {
            vo.setSplitMoney(NumberUtil.divide100(new BigDecimal(log.getSplitMoney())));
        }
        return vo;
    }
}
